-- Warborg is Wargames playing on network
-- Copyright (C) 2011 Manuel De Girardi

-- This Program is Free Software: You Can Redistribute It and/or Modify
-- It Under The Terms of The GNU General Public License As Published By
-- The Free Software Foundation, Either Version 3 of The License, or
-- (at Your Option) Any Later Version.

-- This Program is Distributed in The Hope That It Will Be Useful,
-- But WITHOUT ANY WARRANTY; Without Even The Implied Warranty of
-- MERCHANTABILITY or FITNESS for A PARTICULAR PURPOSE.  See The
-- GNU General Public License for More Details.

-- You Should Have Received A Copy of The GNU General Public License
-- Along with This Program.  if not, See <Http://Www.Gnu.Org/Licenses/>.
with System.Os_Lib;
use System;
with Warborg;
use Warborg;
with Gnat.Sockets;
use Gnat.Sockets;

with Reborg_Status;
procedure Reborg is

   Srv_Adr,Adr                 : Sock_Addr_Type;
   Srv_Socket                  : Socket_Type;
   Clt_Socket                  : Socket_Type;
   Channel                     : Stream_Access;
   Success                     : Boolean := False;
   Xterm_Id                    : Os_Lib.Process_Id;
   Hostname, Logname, Password : String_Access;
begin

   Srv_Adr.Addr := Any_Inet_Addr;
   Srv_Adr.Port := Reborg_Port;
   Create_Socket(Srv_Socket);
   Set_Socket_Option
     (Srv_Socket,
         Socket_Level,
      (Reuse_Address, True));
   delay 0.2;
   Bind_Socket(Srv_Socket,Srv_Adr);
   Listen_Socket(Srv_Socket);
   while not Reborg_Status.End_Of_Program loop

      Accept_Socket(Srv_Socket, Clt_Socket ,Adr);
      Channel := Stream(Clt_Socket);
      String'Output(Channel, "Hello World!");
      if Boolean'Input(Channel) then
         Hostname := new String ' (String'Input(Channel));
         Logname := new String ' (String'Input(Channel));
         Password := new String ' (String'Input(Channel));



         declare
            Xterm_Parameters            : Os_Lib.Argument_List_Access :=
              new Os_Lib.Argument_List ' (new String ' ("-e"),
                                          new String ' ("/bin/bash"),
                                          new String ' ("-c"),
                                          new String ' ("/usr/bin/xborg " & Hostname.all & ' ' & Logname.all & ' ' & Password.all));

         begin

            Xterm_Id := Os_Lib.Non_Blocking_Spawn(Program_Name => "/usr/bin/xterm",
                                                  Args => Xterm_Parameters.all);

            delay 1.0;
         end;



      else
         Reborg_Status.End_Of_Program := True;
      end if;
   end loop;
end Reborg;

